function Client(element, view)
{
  if (view == null)
    view = new jQueryView("Client", element);

  timeline = null;

  registerObjectProperties(this, view, ['Username', 'TweetText', 'SendButton', 'StatusMessage']);

  this.whenSendButtonIsClicked(function()
  {
    var text = this.getTweetText();
    this.sendTweet(text);
    this.setStatusMessage("Tweet sent!");
    this.clearTweetTextbox();
    this.addSentTweetToTimeline(text);
  })

  this.setTimeline = function(value)
  {
    timeline = value;
  }

  this.sendTweet = function(text)
  {
    $.post('/home/tweet', { user: this.getUsername(), text: text }, function(result)
    {
    }, 'json');
  }

  this.clearTweetTextbox = function()
  {
    this.setTweetText("");
  }

  this.addSentTweetToTimeline = function(text)
  {
    var tweet = new Tweet(null, new UnboundView());
    tweet.setUser(this.getUsername());
    tweet.setText(text);
    timeline.prependToTweets(tweet);
  }
}

function Timeline(element, view)
{
  if (view == null)
    view = new jQueryView("Timeline", element);

  registerList(this, view, "Tweets", Tweet);
}

function Tweet(element, view)
{
  if (view == null)
    view = new jQueryView("Tweet", element);

  registerObjectProperties(this, view, ['User', 'Text']);
}
