
describe("When a tweet is sent", function()
{
  beforeEach(function()
  {
    client = new Client(null, new ViewTestDouble());
    client.setUsername("jonkruger");
    timeline = new Timeline(null, new ViewTestDouble());
    client.setTimeline(timeline);

    spyOn($, "post");
    client.setTweetText("This is a test tweet")
    client.clickSendButton();
  });

	it("should send the tweet to the server", function()
	{
    expect($.post).toHaveBeenCalled();
    expect($.post.mostRecentCall.args[0]).toEqual('/home/tweet')
    expect($.post.mostRecentCall.args[1].user).toEqual('jonkruger')
    expect($.post.mostRecentCall.args[1].text).toEqual('This is a test tweet')
    expect($.post.mostRecentCall.args[3]).toEqual('json')
	});
	
	it("should add the tweet to the timeline", function()
	{
		expect(timeline.getTweets().length).toEqual(1);
    expect(timeline.getTweets()[0].getText()).toEqual("This is a test tweet");
    expect(timeline.getTweets()[0].getUser()).toEqual("jonkruger");
	});
	
	it("should show a message saying that the tweet was sent", function()
	{
	  expect(client.getStatusMessage()).toEqual("Tweet sent!");
	});
	
	it("should clear out the tweet textbox", function()
	{
		expect(client.getTweetText()).toEqual("");
	});
});
